unit TipFrm;

interface

uses
  {$IFDEF WIN32}Windows,{$ELSE}WinTypes,WinProcs,{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TTipsForm = class(TForm)
    TipPanel: TPanel;
    ShowChk: TCheckBox;
    OKBtn: TButton;
    NextBtn: TButton;
    PrevBtn: TButton;
    TipLbl: TLabel;
    Image1: TImage;
    TipTitleLbl: TLabel;
    btnCopy: TButton;
// rbw begin change
    procedure MakeTipFit;
// rbw end change
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure NextBtnClick(Sender: TObject);
    procedure PrevBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnCopyClick(Sender: TObject);
  private
    { Private declarations }
    PanelWidthDelta, PanelHeightDelta, TipWidthDelta, TipHeightDelta : integer;
  public
    { Public declarations }
    Tips : TStrings;
    CurrentTip : integer;
    CRLF : string;
    IsRandom : boolean;
  end;

var
  TipsForm: TTipsForm;

implementation

uses Clipbrd, ALSTDlg;

{$R *.DFM}

function ReplaceStr(const S, Srch, Replace: string): string;
var
  I: Integer;
  Source: string;
begin
  Source := S;
  Result := '';
  repeat
    I := Pos(Srch, Source);
    if I > 0 then begin
      Result := Result + Copy(Source, 1, I - 1) + Replace;
      Source := Copy(Source, I + Length(Srch), MaxInt);
    end
    else Result := Result + Source;
  until I <= 0;
end;

procedure TTipsForm.FormCreate(Sender: TObject);
begin
     Tips := TStringList.Create;
     PanelWidthDelta := Width - TipPanel.Width;
     PanelHeightDelta := Height - TipPanel.Height;
     TipWidthDelta := Width - TipLbl.Width;
     TipHeightDelta := Height - TipLbl.Height;
end;

procedure TTipsForm.FormDestroy(Sender: TObject);
begin
     Tips.Free;
end;

procedure TTipsForm.NextBtnClick(Sender: TObject);
var
   i : integer;
begin
     if IsRandom then begin
        Randomize;
        i := Round(Random(Tips.Count-1));
        if (i = CurrentTip) and (Tips.Count > 1) then Inc(i);
        CurrentTip := i;
     end
     else
        if CurrentTip < Tips.Count-1 then Inc(CurrentTip)
                                     else CurrentTip := 0;

     TipLbl.Caption := ReplaceStr(Tips[CurrentTip],CRLF,#13#10);
// rbw begin change
     MakeTipFit;
// rbw end change
end;

procedure TTipsForm.PrevBtnClick(Sender: TObject);
begin
     if CurrentTip = 0 then CurrentTip := Tips.Count-1
                       else Dec(CurrentTip);

     TipLbl.Caption := ReplaceStr(Tips[CurrentTip],CRLF,#13#10);
// rbw begin change
     MakeTipFit;
// rbw end change
end;

procedure TTipsForm.OKBtnClick(Sender: TObject);
begin
     Close;
end;

procedure TTipsForm.FormResize(Sender: TObject);
begin
  TipPanel.Width  := Width - PanelWidthDelta;
  TipPanel.Height := Height - PanelHeightDelta;
  TipLbl.Width    := Width - TipWidthDelta;
  TipLbl.Height   := Height - TipHeightDelta;
end;

procedure TTipsForm.btnCopyClick(Sender: TObject);
begin
  ClipBoard.AsText := TipLbl.Caption;
end;

// rbw begin change
procedure TTipsForm.MakeTipFit;
begin
  TipLbl.Width    := Width - TipWidthDelta;
  TipLbl.AutoSize := True;
  TipLbl.AutoSize := False;
  if TipLbl.Top + TipLbl.Height + 20 > TipPanel.Height then
  begin
    Height := Height + (TipLbl.Top + TipLbl.Height + 20 - TipPanel.Height);
  end;
end;
// rbw end change

end.
