unit TipOfTheDayEditors;

interface

uses
  {$DEFINE VCL6ORABOVE}
  {$IFDEF WIN32}Windows,{$ELSE}WinTypes, WinProcs,{$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms,
  {$IFDEF VCL6ORABOVE}DesignIntf, DesignEditors,{$ELSE}Dsgnintf,{$ENDIF}
   Dialogs, INIFiles{$IFDEF WIN32}, Registry{$ENDIF}, ALSTDlg;

type
  TTipDialogEditor = class(TDefaultEditor)
  public
    procedure ExecuteVerb(Index : Integer); override;
    function GetVerb(Index : Integer): string; override;
    function GetVerbCount : Integer; override;
    procedure Edit; override;
  end;

  TAbout = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  TFileNameProperty = class (TStringProperty)
  public
      function getattributes: TPropertyattributes; override;
      procedure Edit; override;
  end;

procedure Register;

implementation

uses TipFrm;

procedure Register;
begin
  RegisterComponents('Samples', [TALSTipDlg]);
  RegisterComponentEditor(TALSTipDlg, TTipDialogEditor);
  RegisterPropertyEditor(TypeInfo(string), TALSTipDlg, 'ABOUT', TAbout);
  RegisterPropertyEditor(Typeinfo(string), TALSTipDlg, 'INIFile', TFileNameProperty);
end;

{////////////////////////////////////////////////////////////////////////////}
{                                                                            }
{ Dialog design-time preview support                                         }
{                                                                            }
{////////////////////////////////////////////////////////////////////////////}

procedure TTipDialogEditor.ExecuteVerb(Index: Integer);
begin
  if Index <> 0 then Exit;
  Edit;
end;

function TTipDialogEditor.GetVerb(Index: Integer): AnsiString;
begin
  Result := 'Test Tips Dialog';
end;

function TTipDialogEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

procedure TTipDialogEditor.Edit;
begin
   TALSTipDlg(Component).Execute;
end;


{////////////////////////////////////////////////////////////////////////////}
{                                                                            }
{ ABOUT property editor definition                                           }
{                                                                            }
{////////////////////////////////////////////////////////////////////////////}

procedure TAbout.Edit;
begin
  Application.MessageBox('ALS Tip of the Day Dialog component v1.00 for Delphi 1,2,3,4 '+ #13#10+
                         '(C) 1998 Andrew Lazarov.' + #13#10 +
                         'This component is freeware.',
                         'About TALSTipDlg Component', MB_OK + MB_ICONINFORMATION);
end;

function TAbout.GetAttributes: TPropertyAttributes;
begin
  Result:= [paMultiSelect, paDialog, paReadOnly];
end;

function TAbout.GetValue: string;
begin
  Result:= '(about)';
end;


{////////////////////////////////////////////////////////////////////////////}
{                                                                            }
{ INIFile property editor definition                                         }
{                                                                            }
{////////////////////////////////////////////////////////////////////////////}

function TFileNameProperty.GetAttributes;
begin
  Result := [paDialog];
end;

procedure TFilenameProperty.edit;
var
  MFileOpen: TOpenDialog;
begin
  MFileOpen := TOpenDialog.Create(Application);
  MFileOpen.Filename := GetValue;
  MFileOpen.Filter := 'All files|*.*';
  MFileOpen.Options := MFileOpen.Options + [ofPathMustExist,ofFileMustExist];
  try
    if MFileOpen.Execute then SetValue(MFileOpen.Filename);
  finally
    MFileOpen.Free;
  end;
end;



end.
